/***************************************************************
 * Name:      BHControlApp.cpp
 * Purpose:   Code for Application Class
 * Author:    Kevin Doo ()
 * Created:   2009-05-26
 * Copyright: Kevin Doo ()
 * License:
 **************************************************************/

#include "BHControlApp.h"
//(*AppHeaders
//*)

BHControlFrame* BHControlApp::Frame;

IMPLEMENT_APP(BHControlApp);

bool BHControlApp::OnInit()
{
    //(*AppInitialize
    bool wxsOK = true;

    if (wxsOK)
    {
    	Frame = new BHControlFrame(NULL);
    	Frame->Show();
    	SetTopWindow(Frame);
    }

    return wxsOK;
}

int BHControlApp::OnExit() {
    return 0;
}
