#ifndef NODECONDEXPR_H_INCLUDED
#define NODECONGEXPR_H_INCLUDED

#include "NodeExpr.h"

//! Node class for used in parsing and interpreting expressions

class NodeCondExpr : public NodeExpr {

    public:
        NodeCondExpr(NodeExpr* cond, NodeExpr* condTrue, NodeExpr* condFalse);
        virtual ~NodeCondExpr();

        //recursive functions
        virtual void Print();
        virtual bool Subst(wxString name, float* val);
        virtual float Interp();

    private:
        wxString m_name;
        NodeExpr* condition;
        NodeExpr* m_true;
        NodeExpr* m_false;
};

#endif
