#include "HandFinger.h"

#include "HandModel.h"

#define _CULL_FACE	GL_BACK
#define _MAT_FACE	GL_FRONT_AND_BACK

#define SELECTED_VALUE 0.4f

GLfloat ambMatFingertip0000[]=
{
	0.8490f, 0.8490f, 0.8490f, 1.0000f
};
GLfloat diffMatFingertip0000[]=
{
	0.7917f, 0.7917f, 0.7917f, 1.0000f
};
GLfloat specMatFingertip0000[]=
{
	0.6591f, 0.6591f, 0.6591f, 1.0000f
};
GLfloat emissMatFingertip0000[]=
{
	0.1573f, 0.1573f, 0.1573f, 1.0000f
};



GLfloat ambMatFingertip0001[]=
{
	0.8039f, 0.8039f, 0.7294f, 1.0000f
};
GLfloat diffMatFingertip0001[]=
{
	0.8039f, 0.8039f, 0.7294f, 1.0000f
};
GLfloat specMatFingertip0001[]=
{
	0.2412f, 0.2412f, 0.2188f, 1.0000f
};
GLfloat emissMatFingertip0001[]=
{
	0.0000f, 0.0000f, 0.0000f, 1.0000f
};
GLfloat ambMatFingertip0002[]=
{
	0.8039f, 0.8039f, 0.7294f, 1.0000f
};
GLfloat diffMatFingertip0002[]=
{
	0.8039f, 0.8039f, 0.7294f, 1.0000f
};
GLfloat specMatFingertip0002[]=
{
	0.2412f, 0.2412f, 0.2188f, 1.0000f
};
GLfloat emissMatFingertip0002[]=
{
	0.0000f, 0.0000f, 0.0000f, 1.0000f
};
GLfloat ambMatFingertip0003[]=
{
	0.8039f, 0.8039f, 0.7294f, 1.0000f
};
GLfloat diffMatFingertip0003[]=
{
	0.8039f, 0.8039f, 0.7294f, 1.0000f
};
GLfloat specMatFingertip0003[]=
{
	0.2412f, 0.2412f, 0.2188f, 1.0000f
};
GLfloat emissMatFingertip0003[]=
{
	0.0000f, 0.0000f, 0.0000f, 1.0000f
};
GLfloat ambMatFingertip0004[]=
{
	0.8039f, 0.8039f, 0.7294f, 1.0000f
};
GLfloat diffMatFingertip0004[]=
{
	0.8039f, 0.8039f, 0.7294f, 1.0000f
};
GLfloat specMatFingertip0004[]=
{
	0.2412f, 0.2412f, 0.2188f, 1.0000f
};
GLfloat emissMatFingertip0004[]=
{
	0.0000f, 0.0000f, 0.0000f, 1.0000f
};
GLfloat ambMatFingertip0005[]=
{
	0.4282f, 0.4527f, 0.5098f, 1.0000f
};


GLfloat diffMatFingertip0005[]=
{
	0.6588f, 0.6965f, 0.7843f, 1.0000f
};
GLfloat specMatFingertip0005[]=
{
	0.8235f, 0.8706f, 0.9804f, 1.0000f
};
GLfloat emissMatFingertip0005[]=
{
	0.0000f, 0.0000f, 0.0000f, 1.0000f
};
GLfloat ambMatFingertip0006[]=
{
	0.7529f, 0.7529f, 0.7529f, 1.0000f
};
GLfloat diffMatFingertip0006[]=
{
	0.5948f, 0.5948f, 0.5948f, 1.0000f
};
GLfloat specMatFingertip0006[]=
{
	0.6626f, 0.6626f, 0.6626f, 1.0000f
};
GLfloat emissMatFingertip0006[]=
{
	0.1581f, 0.1581f, 0.1581f, 1.0000f
};

GLfloat ambMatFingertip0007[]=
{
	0.5020f, 1.0000f, 0.5020f, 1.0000f
};
GLfloat diffMatFingertip0007[]=
{
	0.5020f, 1.0000f, 0.5020f, 1.0000f
};
GLfloat specMatFingertip0007[]=
{
	0.5020f, 1.0000f, 0.5020f, 1.0000f
};
GLfloat emissMatFingertip0007[]=
{
	0.0000f, 0.0000f, 0.0000f, 1.0000f
};

GLfloat ambMatFingertip0008[]=
{
	0.7529f, 0.7529f, 0.7529f, 1.0000f
};
GLfloat diffMatFingertip0008[]=
{
	0.5948f, 0.5948f, 0.5948f, 1.0000f
};
GLfloat specMatFingertip0008[]=
{
	0.6626f, 0.6626f, 0.6626f, 1.0000f
};
GLfloat emissMatFingertip0008[]=
{
	0.1581f, 0.1581f, 0.1581f, 1.0000f
};

HandFinger::HandFinger(float x, float y, float z, float pitch, float yaw, float roll, float amount, bool pickable)
{
    InitDL();
    CreateColor();
    m_pos[0] = x;
    m_pos[1] = y;
    m_pos[2] = z;
    m_rot[0] = pitch;
    m_rot[1] = yaw;
    m_rot[2] = roll;
    scale = amount;

    m_pickable = pickable;

    rotVal = 0.0;

    m_selected = false;
}

void HandFinger::InitDL() {

    partDL = glGenLists(1);
    glNewList(partDL, GL_COMPILE);
    DrawPart();
    glEndList();

    ambMatFingertip0000[0] = SELECTED_VALUE;

    partDL_selected = glGenLists(2);
    glNewList(partDL_selected, GL_COMPILE);
    DrawPart();
    glEndList();

    ambMatFingertip0000[0] = 0.8490f;
}

void HandFinger::setSelected(bool flag) {
    m_selected = flag;
}

void HandFinger::Render() {


    glPushMatrix();

    //! second rotation of X axis with respect to HandMiddle
    glTranslatef(0.0f, 0.38f/10.0f, -0.5f/10.0f);
    glRotatef(rotVal, 1.0, 0.0, 0.0);
    glTranslatef(0.0f, -0.38f/10.0f, 0.5f/10.0f);

    //!default translation
    glTranslatef(m_pos[0], m_pos[1], m_pos[2]);

    //! rotation of Z axis
    glRotatef(m_rot[2], 0.0, 0.0, 1.0);

    //! rotation of Y axis
    glTranslatef(0.0f, 0.0f, -0.85f/10.0f);
    glRotatef(m_rot[1], 0.0, 1.0, 0.0);
    glTranslatef(0.0f, 0.0f, 0.85f/10.0f);
    //! rotation of X axis
    glTranslatef(0.0f, 0.0f, -0.258f/10.0f);
    glRotatef(m_rot[0], 1.0, 0.0, 0.0);
    glTranslatef(0.0f, 0.0f, 0.258f/10.0f);
    //! default rotation
    glRotatef(-32.0, 1.0, 0.0, 0.0);
    //! default scale
    glScalef(scale, scale, scale);

    if(m_selected) {
        glCallList(partDL_selected);
    } else {
        glCallList(partDL);
    }

    glGetDoublev(GL_MODELVIEW_MATRIX, trans);

    for(unsigned int i = 0; i < m_b_spheres.size(); i++) {
        m_b_spheres[i]->updateTransformation(trans);
    }

    glPopMatrix();

}

void HandFinger::DrawPart()
{
#ifdef DRAW_HAND_MODEL
	glPushAttrib(GL_ALL_ATTRIB_BITS);
	/*** The following lines have been inserted by Vrml2OGL V1.01 ***/
	glEnable(GL_NORMALIZE);
	glCullFace(_CULL_FACE);
	glEnable(GL_CULL_FACE);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_BLEND);
	/*** End of insert **********************************************/
		glPushAttrib(GL_ALL_ATTRIB_BITS);
		glPushMatrix();
		glFrontFace(GL_CCW);
		glMaterialf(_MAT_FACE, GL_SHININESS, 39.6800f);
		glMaterialfv(_MAT_FACE, GL_AMBIENT, ambMatFingertip0000+0);
		glMaterialfv(_MAT_FACE, GL_DIFFUSE, diffMatFingertip0000+0);
		glMaterialfv(_MAT_FACE, GL_SPECULAR, specMatFingertip0000+0);
		glMaterialfv(_MAT_FACE, GL_EMISSION, emissMatFingertip0000+0);
		glBegin(GL_TRIANGLES);

			parseAndDraw3dModel(getHand3dModelFilename(HandModelFilenameFinger1_3d));

		glEnd();
		glPopMatrix();
		glPopAttrib();
		glPushAttrib(GL_ALL_ATTRIB_BITS);
		glPushMatrix();
		glFrontFace(GL_CCW);
		glMaterialf(_MAT_FACE, GL_SHININESS, 40.0000);
		glMaterialfv(_MAT_FACE, GL_AMBIENT, ambMatFingertip0001+0);
		glMaterialfv(_MAT_FACE, GL_DIFFUSE, diffMatFingertip0001+0);
		glMaterialfv(_MAT_FACE, GL_SPECULAR, specMatFingertip0001+0);
		glMaterialfv(_MAT_FACE, GL_EMISSION, emissMatFingertip0001+0);
		glBegin(GL_TRIANGLES);

			parseAndDraw3dModel(getHand3dModelFilename(HandModelFilenameFinger2_3d));

		glEnd();
		glPopMatrix();
		glPopAttrib();
		glPushAttrib(GL_ALL_ATTRIB_BITS);
		glPushMatrix();
		glFrontFace(GL_CCW);
		glMaterialf(_MAT_FACE, GL_SHININESS, 40.0000);
		glMaterialfv(_MAT_FACE, GL_AMBIENT, ambMatFingertip0002+0);
		glMaterialfv(_MAT_FACE, GL_DIFFUSE, diffMatFingertip0002+0);
		glMaterialfv(_MAT_FACE, GL_SPECULAR, specMatFingertip0002+0);
		glMaterialfv(_MAT_FACE, GL_EMISSION, emissMatFingertip0002+0);
		glBegin(GL_TRIANGLES);

			parseAndDraw3dModel(getHand3dModelFilename(HandModelFilenameFinger3_3d));

		glEnd();
		glPopMatrix();
		glPopAttrib();
		glPushAttrib(GL_ALL_ATTRIB_BITS);
		glPushMatrix();
		glFrontFace(GL_CCW);
		glMaterialf(_MAT_FACE, GL_SHININESS, 40.0000);
		glMaterialfv(_MAT_FACE, GL_AMBIENT, ambMatFingertip0003+0);
		glMaterialfv(_MAT_FACE, GL_DIFFUSE, diffMatFingertip0003+0);
		glMaterialfv(_MAT_FACE, GL_SPECULAR, specMatFingertip0003+0);
		glMaterialfv(_MAT_FACE, GL_EMISSION, emissMatFingertip0003+0);
		glBegin(GL_TRIANGLES);

			parseAndDraw3dModel(getHand3dModelFilename(HandModelFilenameFinger4_3d));

		glEnd();
		glPopMatrix();
		glPopAttrib();
		glPushAttrib(GL_ALL_ATTRIB_BITS);
		glPushMatrix();
		glFrontFace(GL_CCW);
		glMaterialf(_MAT_FACE, GL_SHININESS, 40.0000);
		glMaterialfv(_MAT_FACE, GL_AMBIENT, ambMatFingertip0004+0);
		glMaterialfv(_MAT_FACE, GL_DIFFUSE, diffMatFingertip0004+0);
		glMaterialfv(_MAT_FACE, GL_SPECULAR, specMatFingertip0004+0);
		glMaterialfv(_MAT_FACE, GL_EMISSION, emissMatFingertip0004+0);
		glBegin(GL_TRIANGLES);

			parseAndDraw3dModel(getHand3dModelFilename(HandModelFilenameFinger5_3d));

		glEnd();
		glPopMatrix();
		glPopAttrib();
		glPushAttrib(GL_ALL_ATTRIB_BITS);
		glPushMatrix();
		glFrontFace(GL_CCW);
		glMaterialf(_MAT_FACE, GL_SHININESS, 51.2000f);
		glMaterialfv(_MAT_FACE, GL_AMBIENT, ambMatFingertip0005+0);
		glMaterialfv(_MAT_FACE, GL_DIFFUSE, diffMatFingertip0005+0);
		glMaterialfv(_MAT_FACE, GL_SPECULAR, specMatFingertip0005+0);
		glMaterialfv(_MAT_FACE, GL_EMISSION, emissMatFingertip0005+0);
		glBegin(GL_TRIANGLES);

			parseAndDraw3dModel(getHand3dModelFilename(HandModelFilenameFinger6_3d));

		glEnd();
		glPopMatrix();
		glPopAttrib();
		glPushAttrib(GL_ALL_ATTRIB_BITS);
		glPushMatrix();
		glFrontFace(GL_CCW);
		glMaterialf(_MAT_FACE, GL_SHININESS, 26.8800f);
		glMaterialfv(_MAT_FACE, GL_AMBIENT, ambMatFingertip0006+0);
		glMaterialfv(_MAT_FACE, GL_DIFFUSE, diffMatFingertip0006+0);
		glMaterialfv(_MAT_FACE, GL_SPECULAR, specMatFingertip0006+0);
		glMaterialfv(_MAT_FACE, GL_EMISSION, emissMatFingertip0006+0);
		glBegin(GL_TRIANGLES);

			parseAndDraw3dModel(getHand3dModelFilename(HandModelFilenameFinger7_3d));

		glEnd();
		glPopMatrix();
		glPopAttrib();
		glPushAttrib(GL_ALL_ATTRIB_BITS);
		glPushMatrix();
		glFrontFace(GL_CCW);
		glMaterialf(_MAT_FACE, GL_SHININESS, 39.6800f);
		glMaterialfv(_MAT_FACE, GL_AMBIENT, ambMatFingertip0007+0);
		glMaterialfv(_MAT_FACE, GL_DIFFUSE, diffMatFingertip0007+0);
		glMaterialfv(_MAT_FACE, GL_SPECULAR, specMatFingertip0007+0);
		glMaterialfv(_MAT_FACE, GL_EMISSION, emissMatFingertip0007+0);
		glBegin(GL_TRIANGLES);

			parseAndDraw3dModel(getHand3dModelFilename(HandModelFilenameFinger8_3d));

		glEnd();
		glPopMatrix();
		glPopAttrib();
		glPushAttrib(GL_ALL_ATTRIB_BITS);
		glPushMatrix();
		glFrontFace(GL_CCW);
		glMaterialf(_MAT_FACE, GL_SHININESS, 26.8800f);
		glMaterialfv(_MAT_FACE, GL_AMBIENT, ambMatFingertip0008+0);
		glMaterialfv(_MAT_FACE, GL_DIFFUSE, diffMatFingertip0008+0);
		glMaterialfv(_MAT_FACE, GL_SPECULAR, specMatFingertip0008+0);
		glMaterialfv(_MAT_FACE, GL_EMISSION, emissMatFingertip0008+0);
		glBegin(GL_TRIANGLES);

			parseAndDraw3dModel(getHand3dModelFilename(HandModelFilenameFinger9_3d));

		glEnd();
		glPopMatrix();
		glPopAttrib();
	/*** The following lines have been inserted by Vrml2OGL V1.01 ***/
	glDisable(GL_BLEND);
	glDisable(GL_CULL_FACE);
	glDisable(GL_NORMALIZE);
	/*** End of insert **********************************************/
	glPopAttrib();
#endif
}
