/***************************************************************
 * Name:      BHControlApp.h
 * Purpose:   Defines Application Class
 * Author:    Kevin Doo ()
 * Created:   2009-05-26
 * Copyright: Kevin Doo ()
 * License:
 **************************************************************/

#ifndef BHCONTROLAPP_H
#define BHCONTROLAPP_H

#include <wx/app.h>
#include "BHControlMain.h"

class BHControlApp : public wxApp
{
    public:
        virtual bool OnInit();
        virtual int OnExit();

        static BHControlFrame* GetBHControlFrame() { return Frame; }

    private:
        static BHControlFrame* Frame;
};

#endif // BHCONTROLAPP_H
