#include "MyEvents.h"

IMPLEMENT_DYNAMIC_CLASS(RTAbortEvent, wxEvent)
DEFINE_EVENT_TYPE(myRT_ABORT_EVENT)

RTAbortEvent::RTAbortEvent(wxWindow* win)
{
	SetEventType(myRT_ABORT_EVENT);
	SetEventObject(win);
}

wxEvent *RTAbortEvent::Clone() const
{
	return new RTAbortEvent(*this);
}

/////////////////////////////////////////////////

IMPLEMENT_DYNAMIC_CLASS(RTRunEvent, wxEvent)
DEFINE_EVENT_TYPE(myRT_RUN_EVENT)

RTRunEvent::RTRunEvent(wxWindow* win)
{
	SetEventType(myRT_RUN_EVENT);
	SetEventObject(win);
}

wxEvent *RTRunEvent::Clone() const
{
	return new RTRunEvent(*this);
}
