#include "NodeVar.h"

NodeVar::NodeVar(wxString name, int motor) {
    m_name = name;
    m_motor = motor;
    hasValue = false;
    m_value = 0;
    m_left = 0;
    m_right = 0;
}

NodeVar::~NodeVar() {

}

//! substitute recursively
bool NodeVar::Subst(wxString name, float* val) {
    if(m_name.Cmp(name) == 0) {
        m_value = val;
        hasValue = true;
    }

    return true;
}

//! interpret recursively
float NodeVar::Interp() {
    if (hasValue) {
        return *m_value;
    } else {
        wxPuts(wxT("BAD! NO VALUE FOUND FOR NodeVar: ") + m_name + wxT("\n"));
        return 0;
    }
}

//! print recursively
void NodeVar::Print() {
    wxPuts(wxT("NodeVar: val is ") + m_name + wxT(" motor is: ") + wxString::Format(wxT("%i"), m_motor));
}
