#ifndef NODEVAR_H_INCLUDED
#define NODEVAR_H_INCLUDED

#include "NodeExpr.h"

class NodeVar : public NodeExpr {

    public:
        NodeVar(wxString name, int motor);
        virtual ~NodeVar();
        virtual void Print();
        virtual bool Subst(wxString name, float* val);
        virtual float Interp();

    private:
        wxString m_name;
        int m_motor;
        float* m_value;
        bool hasValue;
};

#endif // NODEVAR_H_INCLUDED
