#include "HandBase.h"

#include "HandModel.h"

#define _CULL_FACE	GL_BACK
#define _MAT_FACE	GL_FRONT_AND_BACK

GLfloat ambMatB2581edited0000[]=
{
	1.0000f, 1.0000f, 0.5020f, 1.0000f
};
GLfloat diffMatB2581edited0000[]=
{
	1.0000f, 1.0000f, 0.5020f, 1.0000f
};
GLfloat specMatB2581edited0000[]=
{
	1.0000f, 1.0000f, 0.5020f, 1.0000f
};
GLfloat emissMatB2581edited0000[]=
{
	0.0000f, 0.0000f, 0.0000f, 1.0000f
};

HandBase::HandBase(float x, float y, float z, float pitch, float yaw, float roll, float amount, bool pickable)
{
    InitDL();
    CreateColor();
    m_pos[0] = x;
    m_pos[1] = y;
    m_pos[2] = z;
    m_rot[0] = pitch;
    m_rot[1] = yaw;
    m_rot[2] = roll;
    scale = amount;
    m_pickable = pickable;
}

void HandBase::DrawPart()
{
#ifdef DRAW_HAND_MODEL
	glPushAttrib(GL_ALL_ATTRIB_BITS);
	/*** The following lines have been inserted by Vrml2OGL V1.01 ***/
	glEnable(GL_NORMALIZE);
	glCullFace(_CULL_FACE);
	glEnable(GL_CULL_FACE);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_BLEND);
	/*** End of insert **********************************************/
		glPushAttrib(GL_ALL_ATTRIB_BITS);
		glPushMatrix();
		glFrontFace(GL_CCW);
		glMaterialf(_MAT_FACE, GL_SHININESS, 39.6800f);
		glMaterialfv(_MAT_FACE, GL_AMBIENT, ambMatB2581edited0000);
		glMaterialfv(_MAT_FACE, GL_DIFFUSE, diffMatB2581edited0000);
		glMaterialfv(_MAT_FACE, GL_SPECULAR, specMatB2581edited0000);
		glMaterialfv(_MAT_FACE, GL_EMISSION, emissMatB2581edited0000);
		glBegin(GL_TRIANGLES);

			parseAndDraw3dModel(getHand3dModelFilename(HandModelFilenameBase_3d));

		glEnd();
		glPopMatrix();
		glPopAttrib();
	/*** The following lines have been inserted by Vrml2OGL V1.01 ***/
	glDisable(GL_BLEND);
	glDisable(GL_CULL_FACE);
	glDisable(GL_NORMALIZE);
	/*** End of insert **********************************************/
	glPopAttrib();
#endif
}
